SystemOrganization addCategory: #'AjaxifiedComponents-Example'!

WAAjaxifiedComponent subclass: #AjaxifiedCounter
	instanceVariableNames: 'value id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AjaxifiedComponents-Example'!

!AjaxifiedCounter methodsFor: 'ajaxifiedupdate' stamp: 'JohanBrichau 8/26/2011 17:03'!
id 
	^ id! !

!AjaxifiedCounter methodsFor: 'initialization' stamp: 'JohanBrichau 8/26/2011 17:31'!
initialize 
	super initialize.
	value := 0.
	! !

!AjaxifiedCounter methodsFor: 'rendering' stamp: 'JohanBrichau 8/27/2011 10:56'!
renderContentInternalOn: html 
	html heading 
		level: 2;
		with: value.
	html anchor
		callbackWithAjaxUpdate: [ value := value + 1. self markDirty];
		with: '+'.
	html space.
	html anchor
		callback: [ value := value -1 ];
		with: '-'.! !

!AjaxifiedCounter methodsFor: 'rendering' stamp: 'JohanBrichau 8/26/2011 14:53'!
renderContentOn: html 
	html div
		id: (id := html nextId);
		with: [self renderContentInternalOn: html]! !

!AjaxifiedCounter methodsFor: 'actions' stamp: 'JohanBrichau 8/27/2011 11:17'!
reset 
	value := 0.
	self markDirty.! !

WAAjaxifiedComponent subclass: #AjaxifiedCounterMatrix
	instanceVariableNames: 'counterMatrix id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AjaxifiedComponents-Example'!

!AjaxifiedCounterMatrix methodsFor: 'accessing' stamp: 'JohanBrichau 8/26/2011 17:20'!
children 
	| children |
	children := OrderedCollection new.
	counterMatrix do:[:row |
		row do:[:counter | children add: counter]].
	^children! !

!AjaxifiedCounterMatrix methodsFor: 'accessing' stamp: 'JohanBrichau 8/27/2011 11:19'!
id 
	^ id! !

!AjaxifiedCounterMatrix methodsFor: 'initialization' stamp: 'JohanBrichau 8/26/2011 15:03'!
initialize
	| column |
	super initialize.
	counterMatrix := OrderedCollection new.
	5 timesRepeat:[ 
		column := OrderedCollection new.
		5 timesRepeat: [column add: AjaxifiedCounter new].
		counterMatrix add: column.].
! !

!AjaxifiedCounterMatrix methodsFor: 'rendering' stamp: 'JohanBrichau 8/27/2011 11:48'!
renderContentOn: html 
	html table
		id: (id := html nextId);
		with: [
		counterMatrix doWithIndex:[:row :y |
			html tableRow: [ 
				row doWithIndex: [:data :x | 
					html tableData
						id: 'coord', x asString , y asString;
						with: [data renderOn: html]]]].
			
		html tableRow:[
			html tableData
				colSpan: 5;
				with: [
						html button
							onClick:  (html ajaxifiedUpdateScriptWith: [self resetCounters]);
							with: 'Reset']]].! !

!AjaxifiedCounterMatrix methodsFor: 'actions' stamp: 'JohanBrichau 8/27/2011 11:17'!
resetCounters 
	self children do:[:c | c reset].
	self markDirty.! !

WAAjaxifiedComponent subclass: #AjaxifiedCounterPage
	instanceVariableNames: 'matrices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AjaxifiedComponents-Example'!

!AjaxifiedCounterPage class methodsFor: 'testing' stamp: 'JohanBrichau 8/27/2011 10:57'!
canBeRoot
	^ true! !

!AjaxifiedCounterPage class methodsFor: 'testing' stamp: 'PaulDeBruicker 11/16/2011 07:47'!
initialize
	"self initialize"

	WAAdmin register: self asApplicationAt: 'AjaxifiedCounterPage'! !

!AjaxifiedCounterPage methodsFor: 'accessing' stamp: 'JohanBrichau 8/27/2011 10:59'!
children 
	^ matrices! !

!AjaxifiedCounterPage methodsFor: 'rendering' stamp: 'JohanBrichau 8/27/2011 11:05'!
css
	^ ' body { background-color: black; color: white;} table{border-collapse:collapse; float: left;} td {border: 1px solid white; width: 50px; text-align: center} a {color: orange}'! !

!AjaxifiedCounterPage methodsFor: 'initialization' stamp: 'JohanBrichau 8/27/2011 11:00'!
initialize 
	super initialize.
	matrices := OrderedCollection new add: AjaxifiedCounterMatrix new; add: AjaxifiedCounterMatrix new; yourself! !

!AjaxifiedCounterPage methodsFor: 'rendering' stamp: 'JohanBrichau 8/27/2011 11:05'!
renderContentOn: html 
	html heading
		level: 1;
		with: 'Ajaxified Counter Example'. 
	html paragraph: 'This page shows two Seaside components containing matrices that each contain Seaside counter components. Clicking a + on a counter will only trigger the update of that counter. Clicking a - on a counter will trigger a full page refresh. This demonstrates the ajaxified update mechanism'.
	matrices do:[:m | html render: m. html space.]! !

!AjaxifiedCounterPage methodsFor: 'rendering' stamp: 'PaulDeBruicker 11/16/2011 07:49'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot addStyle: self css.
	anHtmlRoot javascript url: 'https://ajax.googleapis.com/ajax/libs/jquery/1.6.2/jquery.min.js'.
	anHtmlRoot javascript url: 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js'! !
AjaxifiedCounterPage initialize!
